package teamcity.crowd.integration.sync;

import com.atlassian.crowd.model.group.Membership;
import com.google.common.collect.Lists;
import jetbrains.buildServer.groups.SUserGroup;
import jetbrains.buildServer.users.User;

import java.util.*;

public class UsersAndGroupsListsToMapsConverter {
    public List<String> SPECIAL_TEAM_CITY_GROUPS_THAT_SHOULD_STAY = Lists.newArrayList("all-user", "All Users");
    public List<String> SPECIAL_CROWD_GROUPS_THAT_SHOULD_NOT_BE_SYNC = Lists.newArrayList("crowd-administrators");

    public UsersAndGroupsListsToMapsConverter() {
    }

    Map<String, User> allTeamCityUsersAsMap(List<User> directUsers) {
        final HashMap<String, User> map = new HashMap<String, User>();
        for (User user : directUsers) {
            map.put(user.getUsername(), user);
        }
        return map;
    }

    Map<String, Set<String>> membershipsAsMap(Iterable<Membership> memberships) {
        HashMap<String, Set<String>> map = new HashMap<String, Set<String>>();
        for (Membership membership : memberships) {
            if (!SPECIAL_CROWD_GROUPS_THAT_SHOULD_NOT_BE_SYNC.contains(membership.getGroupName()))
                map.put(membership.getGroupName(), membership.getUserNames());
        }
        return map;
    }

    Map<String, SUserGroup> userGroupsAsMap(Collection<SUserGroup> userGroups) {
        HashMap<String, SUserGroup> map = new HashMap<String, SUserGroup>();
        for (SUserGroup userGroup : userGroups) {
            if (!SPECIAL_TEAM_CITY_GROUPS_THAT_SHOULD_STAY.contains(userGroup.getName()))
                map.put(userGroup.getName(), userGroup);
        }
        return map;
    }
}