package teamcity.crowd.integration.web;

import jetbrains.buildServer.controllers.BaseController;
import jetbrains.buildServer.web.openapi.PluginDescriptor;
import jetbrains.buildServer.web.openapi.WebControllerManager;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.nio.charset.Charset;

public class CrowdSyncController extends BaseController {

    private final String SYNC_CONTROLLER = "/teamcity-crowd-integration/sync.html";

    public CrowdSyncController(WebControllerManager webControllerManager) {
        logger.warn("Registering new controller at URL " + SYNC_CONTROLLER);
        webControllerManager.registerController(SYNC_CONTROLLER, this);
    }

    @Nullable
    @Override
    protected ModelAndView doHandle(@NotNull HttpServletRequest httpServletRequest, @NotNull HttpServletResponse httpServletResponse) throws Exception {
        httpServletResponse.setStatus(HttpServletResponse.SC_OK);
        httpServletResponse.setContentType("text/plain");
        httpServletResponse.setCharacterEncoding("UTF-8");
        httpServletResponse.getOutputStream().write("OK".getBytes(Charset.forName("UTF-8")));
        return null;
    }
}
