package teamcity.crowd.integration

import com.atlassian.crowd.integration.http.CrowdHttpAuthenticator
import com.atlassian.crowd.model.user.User
import com.atlassian.crowd.service.client.CrowdClient
import teamcity.crowd.integration.utils.Maybe
import teamcity.crowd.integration.utils.Nothing
import teamcity.crowd.integration.utils.Something

import javax.servlet.http.HttpServletRequest

import static org.hamcrest.CoreMatchers.instanceOf
import static org.hamcrest.MatcherAssert.assertThat
import static org.hamcrest.CoreMatchers.is

class RealCrowdIntegrationClientTest extends GroovyTestCase {

    void test_shouldReturnSomethingWhenUserIsAuthenticated(){
        CrowdHttpAuthenticator authenticator = [getUser:{request -> return [:] as User}] as CrowdHttpAuthenticator
        CrowdClient crowdClient = [:] as CrowdClient
        def request = [:] as HttpServletRequest

        def client = new RealCrowdIntegrationClient(authenticator, crowdClient)

        Maybe<User> userMaybe = client.userAlreadyLoggedIntoCrowd(request)

        assertThat userMaybe.hasValue(), is(true)
        assertThat userMaybe, is(instanceOf(Something.class))
    }

    void test_shouldReturnNothingWhenUserIsNotAuthenticated(){
        CrowdHttpAuthenticator authenticator = [getUser:{request -> return null}] as CrowdHttpAuthenticator
        CrowdClient crowdClient = [:] as CrowdClient
        def request = [:] as HttpServletRequest

        def client = new RealCrowdIntegrationClient(authenticator, crowdClient)

        Maybe<User> userMaybe = client.userAlreadyLoggedIntoCrowd(request)

        assertThat userMaybe.hasValue(), is(false)
        assertThat userMaybe, is(instanceOf(Nothing.class))
    }
}
