package teamcity.crowd.integration.loginModule

import jetbrains.buildServer.serverSide.auth.LoginConfiguration
import teamcity.crowd.integration.CrowdIntegrationClient
import teamcity.crowd.integration.sync.SyncInitializer

import static org.hamcrest.CoreMatchers.is
import static org.hamcrest.CoreMatchers.notNullValue
import static org.hamcrest.MatcherAssert.assertThat

class CrowdLoginModuleDescriptorTest extends GroovyTestCase {

    void test_shouldSetCrowdIntegrationClientWhenModuleInitialize(){
        def loginConfiguration = [registerLoginModule:{}] as LoginConfiguration
        def integrationClient = [:] as CrowdIntegrationClient
        def syncInitializer = [initialize:{}] as SyncInitializer

        def descriptor = new CrowdLoginModuleDescriptor(loginConfiguration, integrationClient, syncInitializer)

        assertThat descriptor.options.size(), is(1)
        assertThat descriptor.options[CrowdIntegrationClient.class.name], is(notNullValue())
    }
}
