package teamcity.crowd.integration.utils

import com.atlassian.crowd.service.client.ClientProperties
import jetbrains.buildServer.web.openapi.PluginException
import teamcity.crowd.integration.mocks.MockLogger

class PluginConfigurationTests extends GroovyTestCase {

    void test_shouldReadPropertiesFromPropertyFile() {
        def pluginConfiguration = new PluginConfiguration(
                new File(".").absolutePath,
                "src\\test\\resources\\teamcity-crowd-plugin.properties",
                [updateProperties: { properties -> assert properties != null },
                        getApplicationName: { "" },
                        getApplicationPassword: { "" },
                        getApplicationAuthenticationURL: { "" },
                        getBaseURL: { "" }] as ClientProperties,
                new MockLogger()
        )

        assert pluginConfiguration.teamCityGroupsSyncEnabled == false
        assert pluginConfiguration.teamCityUsersSyncEnabled == true
        assert pluginConfiguration.teamCityGroupsSyncInterval == 42
        assert pluginConfiguration.teamCityUsersSyncInterval == 42
        assert pluginConfiguration.teamCitySyncDelay == 22
    }

    void test_shouldComplainALotWhenClientConfigurationFileIsNotThere() {
        try {
            new PluginConfiguration(new File(".").absolutePath, "ssome.properties", [:] as ClientProperties, new MockLogger())
            fail("Should drop dead with Plugin exception")
        } catch (PluginException e) {
            assert true
        }
    }
}
