package teamcity.crowd.integration;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.AbstractJUnit4SpringContextTests;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import teamcity.crowd.integration.utils.PluginConfiguration;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.is;


@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {
        "classpath:build-server-plugin-TeamCityCrowdIntegration.xml",
        "classpath:test-build-server-plugin-TeamCityCrowdIntegration.xml"
})
public class PluginConfigurationTest extends AbstractJUnit4SpringContextTests {

    @Autowired
    private PluginConfiguration pluginConfiguration;

    @Test
    public void shouldReturnGroupSyncInterval() throws Exception {
        assertThat(pluginConfiguration.getTeamCityGroupsSyncInterval(), is(42));
    }

    @Test
    public void testGetTeamCityUsersSyncInterval() throws Exception {
        assertThat(pluginConfiguration.getTeamCityUsersSyncInterval(), is(42));
    }

    @Test
    public void shouldReturnEnabledUserSyncProperty(){
         assertThat(pluginConfiguration.isTeamCityUsersSyncEnabled(), is(true));
    }

    @Test
    public void shouldReturnEnabledGroupsSyncProperty(){
        assertThat(pluginConfiguration.isTeamCityGroupsSyncEnabled(), is(false));
    }

    @Test
    public void shouldReturnSyncDelay(){
        assertThat(pluginConfiguration.getTeamCitySyncDelay(), is(22));
    }

    @Test
    public void shouldModifyCrowdClientProperties(){
        assertThat(pluginConfiguration.getClientProperties().getApplicationName(), is("teamcity2"));
    }

}
